Index: drivers/i2c/i2c-core.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/i2c/i2c-core.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/i2c/i2c-core.c	22 Jul 2004 19:49:29 -0000	1.1
+++ drivers/i2c/i2c-core.c	4 Aug 2004 01:28:53 -0000	1.2
@@ -20,7 +20,7 @@
 /* With some changes from Kyösti Mälkki <kmalkki@cc.hut.fi>.
    All SMBus-related things are written by Frodo Looijaard <frodol@dds.nl> */
 
-/* $Id: i2c-core.c,v 1.1 2004/07/22 19:49:29 joff Exp $ */
+/* $Id: i2c-core.c,v 1.2 2004/08/04 01:28:53 joff Exp $ */
 
 #include <linux/module.h>
 #include <linux/kernel.h>
@@ -33,20 +33,15 @@
 
 /* ----- compatibility stuff ----------------------------------------------- */
 
-#include <linux/version.h>
 #include <linux/init.h>
 
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,1)
-#define init_MUTEX(s) do { *(s) = MUTEX; } while(0)
-#endif
-
 #include <asm/uaccess.h>
 
 /* ----- global defines ---------------------------------------------------- */
 
 /* exclusive access to the bus */
 #define I2C_LOCK(adap) down(&adap->lock)
-#define I2C_UNLOCK(adap) up(&adap->lock) 
+#define I2C_UNLOCK(adap) up(&adap->lock)
 
 #define ADAP_LOCK()	down(&adap_lock)
 #define ADAP_UNLOCK()	up(&adap_lock)
@@ -84,27 +79,17 @@
 static int i2cproc_init(void);
 static void i2cproc_cleanup(void);
 
-#if (LINUX_VERSION_CODE <= KERNEL_VERSION(2,3,27))
-static void monitor_bus_i2c(struct inode *inode, int fill);
-#endif /* (LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,58)) */
-
-static ssize_t i2cproc_bus_read(struct file * file, char * buf,size_t count, 
+static ssize_t i2cproc_bus_read(struct file * file, char * buf,size_t count,
                                 loff_t *ppos);
 static int read_bus_i2c(char *buf, char **start, off_t offset, int len,
                            int *eof , void *private);
 
-/* To implement the dynamic /proc/bus/i2c-? files, we need our own 
+/* To implement the dynamic /proc/bus/i2c-? files, we need our own
    implementation of the read hook */
 static struct file_operations i2cproc_operations = {
 	read:		i2cproc_bus_read,
 };
 
-#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,3,48))
-static struct inode_operations i2cproc_inode_operations = {
-	&i2cproc_operations
-};
-#endif
-
 static int i2cproc_initialized = 0;
 
 #else /* undef CONFIG_PROC_FS */
@@ -116,8 +101,8 @@
 
 
 /* ---------------------------------------------------
- * registering functions 
- * --------------------------------------------------- 
+ * registering functions
+ * ---------------------------------------------------
  */
 
 /* -----
@@ -134,7 +119,7 @@
 		if (NULL == adapters[i])
 			break;
 	if (I2C_ADAP_MAX == i) {
-		printk(KERN_WARNING 
+		printk(KERN_WARNING
 		       " i2c-core.o: register_adapter(%s) - enlarge I2C_ADAP_MAX.\n",
 			adap->name);
 		res = -ENOMEM;
@@ -144,7 +129,7 @@
 	adapters[i] = adap;
 	adap_count++;
 	ADAP_UNLOCK();
-	
+
 	/* init data types */
 	init_MUTEX(&adap->lock);
 
@@ -164,34 +149,26 @@
 			goto ERROR1;
 		}
 
-#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,48))
 		proc_entry->proc_fops = &i2cproc_operations;
-#else
-		proc_entry->ops = &i2cproc_inode_operations;
-#endif
-#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,27))
 		proc_entry->owner = THIS_MODULE;
-#else
-		proc_entry->fill_inode = &monitor_bus_i2c;
-#endif /* (LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,58)) */
 		adap->inode = proc_entry->low_ino;
 	}
 
 #endif /* def CONFIG_PROC_FS */
 
 	/* inform drivers of new adapters */
-	DRV_LOCK();	
+	DRV_LOCK();
 	for (j=0;j<I2C_DRIVER_MAX;j++)
-		if (drivers[j]!=NULL && 
+		if (drivers[j]!=NULL &&
 		    (drivers[j]->flags&(I2C_DF_NOTIFY|I2C_DF_DUMMY)))
 			/* We ignore the return code; if it fails, too bad */
 			drivers[j]->attach_adapter(adap);
 	DRV_UNLOCK();
-	
-	DEB(printk("i2c-core.o: adapter %s registered as adapter %d.\n",
+
+	DEB(printk(KERN_DEBUG "i2c-core.o: adapter %s registered as adapter %d.\n",
 	           adap->name,i));
 
-	return 0;	
+	return 0;
 
 
 ERROR1:
@@ -214,7 +191,7 @@
 		if (adap == adapters[i])
 			break;
 	if (I2C_ADAP_MAX == i) {
-		printk( "i2c-core.o: unregister_adapter adap [%s] not found.\n",
+		printk(KERN_WARNING "i2c-core.o: unregister_adapter adap [%s] not found.\n",
 			adap->name);
 		res = -ENODEV;
 		goto ERROR0;
@@ -226,13 +203,13 @@
 	 * this or hell will break loose...
 	 */
 	DRV_LOCK();
-	for (j = 0; j < I2C_DRIVER_MAX; j++) 
+	for (j = 0; j < I2C_DRIVER_MAX; j++)
 		if (drivers[j] && (drivers[j]->flags & I2C_DF_DUMMY))
 			if ((res = drivers[j]->attach_adapter(adap))) {
-				printk("i2c-core.o: can't detach adapter %s "
+				printk(KERN_WARNING "i2c-core.o: can't detach adapter %s "
 				       "while detaching driver %s: driver not "
 				       "detached!",adap->name,drivers[j]->name);
-				goto ERROR1;	
+				goto ERROR1;
 			}
 	DRV_UNLOCK();
 
@@ -247,7 +224,7 @@
 		     * must be deleted, as this would cause invalid states.
 		     */
 			if ((res=client->driver->detach_client(client))) {
-				printk("i2c-core.o: adapter %s not "
+				printk(KERN_ERR "i2c-core.o: adapter %s not "
 					"unregistered, because client at "
 					"address %02x can't be detached. ",
 					adap->name, client->addr);
@@ -264,9 +241,9 @@
 
 	adapters[i] = NULL;
 	adap_count--;
-	
-	ADAP_UNLOCK();	
-	DEB(printk("i2c-core.o: adapter unregistered: %s\n",adap->name));
+
+	ADAP_UNLOCK();
+	DEB(printk(KERN_DEBUG "i2c-core.o: adapter unregistered: %s\n",adap->name));
 	return 0;
 
 ERROR0:
@@ -292,7 +269,7 @@
 		if (NULL == drivers[i])
 			break;
 	if (I2C_DRIVER_MAX == i) {
-		printk(KERN_WARNING 
+		printk(KERN_WARNING
 		       " i2c-core.o: register_driver(%s) "
 		       "- enlarge I2C_DRIVER_MAX.\n",
 			driver->name);
@@ -302,11 +279,11 @@
 
 	drivers[i] = driver;
 	driver_count++;
-	
+
 	DRV_UNLOCK();	/* driver was successfully added */
-	
-	DEB(printk("i2c-core.o: driver %s registered.\n",driver->name));
-	
+
+	DEB(printk(KERN_DEBUG "i2c-core.o: driver %s registered.\n",driver->name));
+
 	ADAP_LOCK();
 
 	/* now look for instances of driver on our adapters
@@ -337,11 +314,11 @@
 		return -ENODEV;
 	}
 	/* Have a look at each adapter, if clients of this driver are still
-	 * attached. If so, detach them to be able to kill the driver 
+	 * attached. If so, detach them to be able to kill the driver
 	 * afterwards.
 	 */
-	DEB2(printk("i2c-core.o: unregister_driver - looking for clients.\n"));
-	/* removing clients does not depend on the notify flag, else 
+	DEB2(printk(KERN_DEBUG "i2c-core.o: unregister_driver - looking for clients.\n"));
+	/* removing clients does not depend on the notify flag, else
 	 * invalid operation might (will!) result, when using stale client
 	 * pointers.
 	 */
@@ -350,16 +327,16 @@
 		struct i2c_adapter *adap = adapters[k];
 		if (adap == NULL) /* skip empty entries. */
 			continue;
-		DEB2(printk("i2c-core.o: examining adapter %s:\n",
+		DEB2(printk(KERN_DEBUG "i2c-core.o: examining adapter %s:\n",
 			    adap->name));
 		if (driver->flags & I2C_DF_DUMMY) {
 		/* DUMMY drivers do not register their clients, so we have to
 		 * use a trick here: we call driver->attach_adapter to
 		 * *detach* it! Of course, each dummy driver should know about
-		 * this or hell will break loose...  
+		 * this or hell will break loose...
 		 */
 			if ((res = driver->attach_adapter(adap))) {
-				printk("i2c-core.o: while unregistering "
+				printk(KERN_WARNING "i2c-core.o: while unregistering "
 				       "dummy driver %s, adapter %s could "
 				       "not be detached properly; driver "
 				       "not unloaded!",driver->name,
@@ -368,17 +345,17 @@
 				return res;
 			}
 		} else {
-			for (j=0;j<I2C_CLIENT_MAX;j++) { 
+			for (j=0;j<I2C_CLIENT_MAX;j++) {
 				struct i2c_client *client = adap->clients[j];
-				if (client != NULL && 
+				if (client != NULL &&
 				    client->driver == driver) {
-					DEB2(printk("i2c-core.o: "
+					DEB2(printk(KERN_DEBUG "i2c-core.o: "
 						    "detaching client %s:\n",
 					            client->name));
 					if ((res = driver->
 							detach_client(client)))
 					{
-						printk("i2c-core.o: while "
+						printk(KERN_ERR "i2c-core.o: while "
 						       "unregistering driver "
 						       "`%s', the client at "
 						       "address %02x of "
@@ -399,15 +376,15 @@
 	drivers[i] = NULL;
 	driver_count--;
 	DRV_UNLOCK();
-	
-	DEB(printk("i2c-core.o: driver unregistered: %s\n",driver->name));
+
+	DEB(printk(KERN_DEBUG "i2c-core.o: driver unregistered: %s\n",driver->name));
 	return 0;
 }
 
 int i2c_check_addr (struct i2c_adapter *adapter, int addr)
 {
 	int i;
-	for (i = 0; i < I2C_CLIENT_MAX ; i++) 
+	for (i = 0; i < I2C_CLIENT_MAX ; i++)
 		if (adapter->clients[i] && (adapter->clients[i]->addr == addr))
 			return -EBUSY;
 	return 0;
@@ -425,7 +402,7 @@
 		if (NULL == adapter->clients[i])
 			break;
 	if (I2C_CLIENT_MAX == i) {
-		printk(KERN_WARNING 
+		printk(KERN_WARNING
 		       " i2c-core.o: attach_client(%s) - enlarge I2C_CLIENT_MAX.\n",
 			client->name);
 		return -ENOMEM;
@@ -433,18 +410,18 @@
 
 	adapter->clients[i] = client;
 	adapter->client_count++;
-	
-	if (adapter->client_register) 
-		if (adapter->client_register(client)) 
-			printk("i2c-core.o: warning: client_register seems "
+
+	if (adapter->client_register)
+		if (adapter->client_register(client))
+			printk(KERN_DEBUG "i2c-core.o: warning: client_register seems "
 			       "to have failed for client %02x at adapter %s\n",
 			       client->addr,adapter->name);
-	DEB(printk("i2c-core.o: client [%s] registered to adapter [%s](pos. %d).\n",
+	DEB(printk(KERN_DEBUG "i2c-core.o: client [%s] registered to adapter [%s](pos. %d).\n",
 		client->name, adapter->name,i));
 
 	if(client->flags & I2C_CLIENT_ALLOW_USE)
 		client->usage_count = 0;
-	
+
 	return 0;
 }
 
@@ -463,14 +440,14 @@
 			client->name);
 		return -ENODEV;
 	}
-	
-	if( (client->flags & I2C_CLIENT_ALLOW_USE) && 
+
+	if( (client->flags & I2C_CLIENT_ALLOW_USE) &&
 	    (client->usage_count>0))
 		return -EBUSY;
-	
-	if (adapter->client_unregister != NULL) 
+
+	if (adapter->client_unregister != NULL)
 		if ((res = adapter->client_unregister(client))) {
-			printk("i2c-core.o: client_unregister [%s] failed, "
+			printk(KERN_ERR "i2c-core.o: client_unregister [%s] failed, "
 			       "client not detached",client->name);
 			return res;
 		}
@@ -478,7 +455,7 @@
 	adapter->clients[i] = NULL;
 	adapter->client_count--;
 
-	DEB(printk("i2c-core.o: client [%s] unregistered.\n",client->name));
+	DEB(printk(KERN_DEBUG "i2c-core.o: client [%s] unregistered.\n",client->name));
 	return 0;
 }
 
@@ -494,7 +471,7 @@
 
 void i2c_dec_use_client(struct i2c_client *client)
 {
-	
+
 	if (client->driver->dec_use != NULL)
 		client->driver->dec_use(client);
 
@@ -502,65 +479,65 @@
 		client->adapter->dec_use(client->adapter);
 }
 
-struct i2c_client *i2c_get_client(int driver_id, int adapter_id, 
+struct i2c_client *i2c_get_client(int driver_id, int adapter_id,
 					struct i2c_client *prev)
 {
 	int i,j;
-	
+
 	/* Will iterate through the list of clients in each adapter of adapters-list
-	   in search for a client that matches the search criteria. driver_id or 
-	   adapter_id are ignored if set to 0. If both are ignored this returns 
+	   in search for a client that matches the search criteria. driver_id or
+	   adapter_id are ignored if set to 0. If both are ignored this returns
 	   first client found. */
-	
-	i = j = 0;  
-	
-	/* set starting point */ 
+
+	i = j = 0;
+
+	/* set starting point */
 	if(prev)
 	{
 		if(!(prev->adapter))
 			return (struct i2c_client *) -EINVAL;
-		
+
 		for(j=0; j < I2C_ADAP_MAX; j++)
 			if(prev->adapter == adapters[j])
 				break;
-		
+
 		/* invalid starting point? */
 		if (I2C_ADAP_MAX == j) {
 			printk(KERN_WARNING " i2c-core.o: get_client adapter for client:[%s] not found\n",
 				prev->name);
 			return (struct i2c_client *) -ENODEV;
-		}	
-		
+		}
+
 		for(i=0; i < I2C_CLIENT_MAX; i++)
 			if(prev == adapters[j]->clients[i])
 				break;
-		
+
 		/* invalid starting point? */
 		if (I2C_CLIENT_MAX == i) {
 			printk(KERN_WARNING " i2c-core.o: get_client client:[%s] not found\n",
 				prev->name);
 			return (struct i2c_client *) -ENODEV;
-		}	
-		
+		}
+
 		i++; /* start from one after prev */
 	}
-	
+
 	for(; j < I2C_ADAP_MAX; j++)
 	{
 		if(!adapters[j])
 			continue;
-			
+
 		if(adapter_id && (adapters[j]->id != adapter_id))
 			continue;
-		
+
 		for(; i < I2C_CLIENT_MAX; i++)
 		{
 			if(!adapters[j]->clients[i])
 				continue;
-				
+
 			if(driver_id && (adapters[j]->clients[i]->driver->id != driver_id))
 				continue;
-			if(adapters[j]->clients[i]->flags & I2C_CLIENT_ALLOW_USE)	
+			if(adapters[j]->clients[i]->flags & I2C_CLIENT_ALLOW_USE)
 				return adapters[j]->clients[i];
 		}
 		i = 0;
@@ -572,12 +549,12 @@
 int i2c_use_client(struct i2c_client *client)
 {
 	if(client->flags & I2C_CLIENT_ALLOW_USE) {
-		if (client->flags & I2C_CLIENT_ALLOW_MULTIPLE_USE) 
+		if (client->flags & I2C_CLIENT_ALLOW_MULTIPLE_USE)
 			client->usage_count++;
 		else {
-			if(client->usage_count > 0) 
+			if(client->usage_count > 0)
 				return -EBUSY;
-			 else 
+			 else
 				client->usage_count++;
 		}
 	}
@@ -598,9 +575,9 @@
 			return -EPERM;
 		}
 	}
-	
+
 	i2c_dec_use_client(client);
-	
+
 	return 0;
 }
 
@@ -611,20 +588,8 @@
 
 #ifdef CONFIG_PROC_FS
 
-#if (LINUX_VERSION_CODE <= KERNEL_VERSION(2,3,27))
-/* Monitor access to /proc/bus/i2c*; make unloading i2c-proc impossible
-   if some process still uses it or some file in it */
-void monitor_bus_i2c(struct inode *inode, int fill)
-{
-	if (fill)
-		MOD_INC_USE_COUNT;
-	else
-		MOD_DEC_USE_COUNT;
-}
-#endif /* (LINUX_VERSION_CODE <= KERNEL_VERSION(2,3,37)) */
-
 /* This function generates the output for /proc/bus/i2c */
-int read_bus_i2c(char *buf, char **start, off_t offset, int len, int *eof, 
+int read_bus_i2c(char *buf, char **start, off_t offset, int len, int *eof,
                  void *private)
 {
 	int i;
@@ -650,7 +615,7 @@
 }
 
 /* This function generates the output for /proc/bus/i2c-? */
-ssize_t i2cproc_bus_read(struct file * file, char * buf,size_t count, 
+ssize_t i2cproc_bus_read(struct file * file, char * buf,size_t count,
                          loff_t *ppos)
 {
 	struct inode * inode = file->f_dentry->d_inode;
@@ -661,7 +626,7 @@
 	int order[I2C_CLIENT_MAX];
 
 	if (count > 4000)
-		return -EINVAL; 
+		return -EINVAL;
 	len_total = file->f_pos + count;
 	/* Too bad if this gets longer (unlikely) */
 	if (len_total > 4000)
@@ -676,12 +641,12 @@
 			   sorted by address */
 			order_nr=0;
 			for (j = 0; j < I2C_CLIENT_MAX; j++) {
-				if ((client = adapters[i]->clients[j]) && 
+				if ((client = adapters[i]->clients[j]) &&
 				    (client->driver->id != I2C_DRIVERID_I2CDEV))  {
-					for(k = order_nr; 
-					    (k > 0) && 
+					for(k = order_nr;
+					    (k > 0) &&
 					    adapters[i]->clients[order[k-1]]->
-					             addr > client->addr; 
+					             addr > client->addr;
 					    k--)
 						order[k] = order[k-1];
 					order[k] = j;
@@ -700,7 +665,7 @@
 			len = len - file->f_pos;
 			if (len > count)
 				len = count;
-			if (len < 0) 
+			if (len < 0)
 				len = 0;
 			if (copy_to_user (buf,kbuf+file->f_pos, len)) {
 				kfree(kbuf);
@@ -724,19 +689,15 @@
 		printk("i2c-core.o: /proc/bus/ does not exist");
 		i2cproc_cleanup();
 		return -ENOENT;
- 	} 
+ 	}
 	proc_bus_i2c = create_proc_entry("i2c",0,proc_bus);
 	if (!proc_bus_i2c) {
-		printk("i2c-core.o: Could not create /proc/bus/i2c");
+		printk(KERN_ERR "i2c-core.o: Could not create /proc/bus/i2c");
 		i2cproc_cleanup();
 		return -ENOENT;
  	}
 	proc_bus_i2c->read_proc = &read_bus_i2c;
-#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,27))
 	proc_bus_i2c->owner = THIS_MODULE;
-#else
-	proc_bus_i2c->fill_inode = &monitor_bus_i2c;
-#endif /* (LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,27)) */
 	i2cproc_initialized += 2;
 	return 0;
 }
@@ -763,7 +724,7 @@
 	int ret;
 
 	if (adap->algo->master_xfer) {
- 	 	DEB2(printk("i2c-core.o: master_xfer: %s with %d msgs.\n",
+ 	 	DEB2(printk(KERN_DEBUG "i2c-core.o: master_xfer: %s with %d msgs.\n",
 		            adap->name,num));
 
 		I2C_LOCK(adap);
@@ -772,7 +733,7 @@
 
 		return ret;
 	} else {
-		printk("i2c-core.o: I2C adapter %04x: I2C level transfers not supported\n",
+		printk(KERN_ERR "i2c-core.o: I2C adapter %04x: I2C level transfers not supported\n",
 		       adap->id);
 		return -ENOSYS;
 	}
@@ -789,10 +750,10 @@
 		msg.flags = client->flags & I2C_M_TEN;
 		msg.len = count;
 		(const char *)msg.buf = buf;
-	
-		DEB2(printk("i2c-core.o: master_send: writing %d bytes on %s.\n",
+
+		DEB2(printk(KERN_DEBUG "i2c-core.o: master_send: writing %d bytes on %s.\n",
 			count,client->adapter->name));
-	
+
 		I2C_LOCK(adap);
 		ret = adap->algo->master_xfer(adap,&msg,1);
 		I2C_UNLOCK(adap);
@@ -802,7 +763,7 @@
 		 */
 		return (ret == 1 )? count : ret;
 	} else {
-		printk("i2c-core.o: I2C adapter %04x: I2C level transfers not supported\n",
+		printk(KERN_ERR "i2c-core.o: I2C adapter %04x: I2C level transfers not supported\n",
 		       client->adapter->id);
 		return -ENOSYS;
 	}
@@ -820,22 +781,22 @@
 		msg.len = count;
 		msg.buf = buf;
 
-		DEB2(printk("i2c-core.o: master_recv: reading %d bytes on %s.\n",
+		DEB2(printk(KERN_DEBUG "i2c-core.o: master_recv: reading %d bytes on %s.\n",
 			count,client->adapter->name));
-	
+
 		I2C_LOCK(adap);
 		ret = adap->algo->master_xfer(adap,&msg,1);
 		I2C_UNLOCK(adap);
-	
-		DEB2(printk("i2c-core.o: master_recv: return:%d (count:%d, addr:0x%02x)\n",
+
+		DEB2(printk(KERN_DEBUG "i2c-core.o: master_recv: return:%d (count:%d, addr:0x%02x)\n",
 			ret, count, client->addr));
-	
+
 		/* if everything went ok (i.e. 1 msg transmitted), return #bytes
 	 	* transmitted, else error code.
 	 	*/
 		return (ret == 1 )? count : ret;
 	} else {
-		printk("i2c-core.o: I2C adapter %04x: I2C level transfers not supported\n",
+		printk(KERN_ERR "i2c-core.o: I2C adapter %04x: I2C level transfers not supported\n",
 		       client->adapter->id);
 		return -ENOSYS;
 	}
@@ -848,7 +809,7 @@
 	int ret = 0;
 	struct i2c_adapter *adap = client->adapter;
 
-	DEB2(printk("i2c-core.o: i2c ioctl, cmd: 0x%x, arg: %#lx\n", cmd, arg));
+	DEB2(printk(KERN_DEBUG "i2c-core.o: i2c ioctl, cmd: 0x%x, arg: %#lx\n", cmd, arg));
 	switch ( cmd ) {
 		case I2C_RETRIES:
 			adap->retries = arg;
@@ -890,17 +851,17 @@
 		found = 0;
 
 		for (i = 0; !found && (address_data->force[i] != I2C_CLIENT_END); i += 3) {
-			if (((adap_id == address_data->force[i]) || 
+			if (((adap_id == address_data->force[i]) ||
 			     (address_data->force[i] == ANY_I2C_BUS)) &&
 			     (addr == address_data->force[i+1])) {
-				DEB2(printk("i2c-core.o: found force parameter for adapter %d, addr %04x\n",
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found force parameter for adapter %d, addr %04x\n",
 				            adap_id,addr));
 				if ((err = found_proc(adapter,addr,0,0)))
 					return err;
 				found = 1;
 			}
 		}
-		if (found) 
+		if (found)
 			continue;
 
 		/* If this address is in one of the ignores, we can forget about
@@ -908,10 +869,10 @@
 		for (i = 0;
 		     !found && (address_data->ignore[i] != I2C_CLIENT_END);
 		     i += 2) {
-			if (((adap_id == address_data->ignore[i]) || 
+			if (((adap_id == address_data->ignore[i]) ||
 			    ((address_data->ignore[i] == ANY_I2C_BUS))) &&
 			    (addr == address_data->ignore[i+1])) {
-				DEB2(printk("i2c-core.o: found ignore parameter for adapter %d, "
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found ignore parameter for adapter %d, "
 				     "addr %04x\n", adap_id ,addr));
 				found = 1;
 			}
@@ -923,22 +884,22 @@
 			    ((address_data->ignore_range[i]==ANY_I2C_BUS))) &&
 			    (addr >= address_data->ignore_range[i+1]) &&
 			    (addr <= address_data->ignore_range[i+2])) {
-				DEB2(printk("i2c-core.o: found ignore_range parameter for adapter %d, "
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found ignore_range parameter for adapter %d, "
 				            "addr %04x\n", adap_id,addr));
 				found = 1;
 			}
 		}
-		if (found) 
+		if (found)
 			continue;
 
-		/* Now, we will do a detection, but only if it is in the normal or 
-		   probe entries */  
+		/* Now, we will do a detection, but only if it is in the normal or
+		   probe entries */
 		for (i = 0;
 		     !found && (address_data->normal_i2c[i] != I2C_CLIENT_END);
 		     i += 1) {
 			if (addr == address_data->normal_i2c[i]) {
 				found = 1;
-				DEB2(printk("i2c-core.o: found normal i2c entry for adapter %d, "
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found normal i2c entry for adapter %d, "
 				            "addr %02x", adap_id,addr));
 			}
 		}
@@ -949,7 +910,7 @@
 			if ((addr >= address_data->normal_i2c_range[i]) &&
 			    (addr <= address_data->normal_i2c_range[i+1])) {
 				found = 1;
-				DEB2(printk("i2c-core.o: found normal i2c_range entry for adapter %d, "
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found normal i2c_range entry for adapter %d, "
 				            "addr %04x\n", adap_id,addr));
 			}
 		}
@@ -961,7 +922,7 @@
 			    ((address_data->probe[i] == ANY_I2C_BUS))) &&
 			    (addr == address_data->probe[i+1])) {
 				found = 1;
-				DEB2(printk("i2c-core.o: found probe parameter for adapter %d, "
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found probe parameter for adapter %d, "
 				            "addr %04x\n", adap_id,addr));
 			}
 		}
@@ -973,11 +934,11 @@
 			   (addr >= address_data->probe_range[i+1]) &&
 			   (addr <= address_data->probe_range[i+2])) {
 				found = 1;
-				DEB2(printk("i2c-core.o: found probe_range parameter for adapter %d, "
+				DEB2(printk(KERN_DEBUG "i2c-core.o: found probe_range parameter for adapter %d, "
 				            "addr %04x\n", adap_id,addr));
 			}
 		}
-		if (!found) 
+		if (!found)
 			continue;
 
 		/* OK, so we really should examine this address. First check
@@ -1100,8 +1061,8 @@
 {
 	union i2c_smbus_data data;
 	int i;
-	if (length > 32)
-		length = 32;
+	if (length > I2C_SMBUS_BLOCK_MAX)
+		length = I2C_SMBUS_BLOCK_MAX;
 	for (i = 1; i <= length; i++)
 		data.block[i] = values[i-1];
 	data.block[0] = length;
@@ -1115,8 +1076,8 @@
 {
 	union i2c_smbus_data data;
 	int i;
-	if (length > 32)
-		length = 32;
+	if (length > I2C_SMBUS_I2C_BLOCK_MAX)
+		length = I2C_SMBUS_I2C_BLOCK_MAX;
 	for (i = 1; i <= length; i++)
 		data.block[i] = values[i-1];
 	data.block[0] = length;
@@ -1125,11 +1086,11 @@
 	                      I2C_SMBUS_I2C_BLOCK_DATA,&data);
 }
 
-/* Simulate a SMBus command using the i2c protocol 
+/* Simulate a SMBus command using the i2c protocol
    No checking of parameters is done!  */
-static s32 i2c_smbus_xfer_emulated(struct i2c_adapter * adapter, u16 addr, 
+static s32 i2c_smbus_xfer_emulated(struct i2c_adapter * adapter, u16 addr,
                                    unsigned short flags,
-                                   char read_write, u8 command, int size, 
+                                   char read_write, u8 command, int size,
                                    union i2c_smbus_data * data)
 {
 	/* So we need to generate a series of msgs. In the case of writing, we
@@ -1139,7 +1100,7 @@
 	unsigned char msgbuf0[34];
 	unsigned char msgbuf1[34];
 	int num = read_write == I2C_SMBUS_READ?2:1;
-	struct i2c_msg msg[2] = { { addr, flags, 1, msgbuf0 }, 
+	struct i2c_msg msg[2] = { { addr, flags, 1, msgbuf0 },
 	                          { addr, flags | I2C_M_RD, 0, msgbuf1 }
 	                        };
 	int i;
@@ -1185,15 +1146,15 @@
 		break;
 	case I2C_SMBUS_BLOCK_DATA:
 		if (read_write == I2C_SMBUS_READ) {
-			printk("i2c-core.o: Block read not supported under "
-			       "I2C emulation!\n");
-		return -1;
+			printk(KERN_ERR "i2c-core.o: Block read not supported "
+			       "under I2C emulation!\n");
+			return -1;
 		} else {
 			msg[0].len = data->block[0] + 2;
-			if (msg[0].len > 34) {
-				printk("i2c-core.o: smbus_access called with "
+			if (msg[0].len > I2C_SMBUS_BLOCK_MAX + 2) {
+				printk(KERN_ERR "i2c-core.o: smbus_access called with "
 				       "invalid block write size (%d)\n",
-				       msg[0].len);
+				       data->block[0]);
 				return -1;
 			}
 			for (i = 1; i <= msg[0].len; i++)
@@ -1201,7 +1162,7 @@
 		}
 		break;
 	default:
-		printk("i2c-core.o: smbus_access called with invalid size (%d)\n",
+		printk(KERN_ERR "i2c-core.o: smbus_access called with invalid size (%d)\n",
 		       size);
 		return -1;
 	}
@@ -1217,7 +1178,7 @@
 			case I2C_SMBUS_BYTE_DATA:
 				data->byte = msgbuf1[0];
 				break;
-			case I2C_SMBUS_WORD_DATA: 
+			case I2C_SMBUS_WORD_DATA:
 			case I2C_SMBUS_PROC_CALL:
 				data->word = msgbuf1[0] | (msgbuf1[1] << 8);
 				break;
@@ -1227,7 +1188,7 @@
 
 
 s32 i2c_smbus_xfer(struct i2c_adapter * adapter, u16 addr, unsigned short flags,
-                   char read_write, u8 command, int size, 
+                   char read_write, u8 command, int size,
                    union i2c_smbus_data * data)
 {
 	s32 res;
@@ -1245,7 +1206,7 @@
 
 
 /* You should always define `functionality'; the 'else' is just for
-   backward compatibility. */ 
+   backward compatibility. */
 u32 i2c_get_functionality (struct i2c_adapter *adap)
 {
 	if (adap->algo->functionality)
@@ -1263,7 +1224,7 @@
 
 static int __init i2c_init(void)
 {
-	printk(KERN_DEBUG "i2c-core.o: i2c core module\n");
+	printk(KERN_INFO "i2c-core.o: i2c core module version %s (%s)\n", I2C_VERSION, I2C_DATE);
 	memset(adapters,0,sizeof(adapters));
 	memset(drivers,0,sizeof(drivers));
 	adap_count=0;
@@ -1271,9 +1232,9 @@
 
 	init_MUTEX(&adap_lock);
 	init_MUTEX(&driver_lock);
-	
+
 	i2cproc_init();
-	
+
 	return 0;
 }
 
@@ -1315,9 +1276,10 @@
 
 MODULE_AUTHOR("Simon G. Vogl <simon@tk.uni-linz.ac.at>");
 MODULE_DESCRIPTION("I2C-Bus main module");
+MODULE_LICENSE("GPL");
+
 MODULE_PARM(i2c_debug, "i");
 MODULE_PARM_DESC(i2c_debug,"debug level");
-MODULE_LICENSE("GPL");
 
 module_init(i2c_init);
 module_exit(i2cproc_cleanup);
